unit DPGrid;
 //f[^\
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Buttons;

type
  TfrmDPGrid = class(TForm)
    StringGrid1: TStringGrid;
    btnOK: TBitBtn;
    Button1: TButton;
    Label1: TLabel;
    btmWrite: TButton;
    SaveDialog1: TSaveDialog;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure StringGrid1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btmWriteClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  frmDPGrid: TfrmDPGrid;

implementation

{$R *.DFM}
uses  spssdio1,spssfile, ValueLabel, vardisp;
const gridlength=8;


procedure TfrmDPGrid.FormCreate(Sender: TObject);

var
   i,i1,j:cardinal;
   x,y:    integer ;
   tstr  :string;
   xday,xmonth,xyear:integer;
begin

    if filename='' then exit;
    filecheck;
   //Obh̍쐬@sƗɃx
   with StringGrid1 do begin
       Colcount:= numV+1;
       Rowcount:= nCases+1;

      for i:=1 to numV do Cells[i,0]:=nameV[i-1];
      for i:=1 to nCases do begin
      tstr:=format('%'+inttostr(gridlength)+'d',[i]) ;
       Cells[0,i]:=tstr;
      end;
   end;
//Obh̒̕
     for i1 := 1 to numV do begin
       if VWide[i1-1]>gridlength then begin
         StringGrid1.ColWidths[i1] :=StringGrid1.ColWidths[0]*Vwide[i1-1] div gridlength;
       end;
       if VWide[i1-1]< gridlength then begin
         x:=Vwide[i1-1]+1;
         y:=length(nameV[i1-1]);
         if x< y then x:= y;
         if x< 4 then x:=4;
         StringGrid1.ColWidths[i1] :=StringGrid1.ColWidths[0]*x div gridlength;
         Vwide[i1-1]:=x;
       end;

    end;
    stringgrid1.options:=stringgrid1.options-[goEditing];
    for i:=0 to numV-1 do begin
       error:=spssGetVarHandle(fh,nameV[i],handlesV[i]);
       if (error <> SPSS_OK) then begin
       showMessage('Error at spssGetVarHandle.: '+errorcode(error));
       exit;
       end;
    end;
    stringgrid1.options:=stringgrid1.options+[goEditing];
    casesPrint:=nCases;
    if nCases=-1 then begin
       showmessage('̃f[^͓ǂݍ݂܂:Matrix DATA ł');
       exit;
    end;

    for j:= 1 to casesPrint do begin
       error:=spssReadCaseRecord(fh);
       if error<>SPSS_OK then begin
          showmessage('f[^ǂݍݒɃguFēx킵Ă');
          exit;
       end;
       for i1:= 1 to numV do begin
        i:=i1-1;
         //                  //spssConvertSPSSDate tŎg
         if (typesV[i]=0) then begin
            error:=spssGetValueNumeric(fh,handlesV[i],nValue);
            if error =SPSS_OK then begin
              if nValue=sysmis then
               tstr:='.'
              else
                 case typesVF[i] of
                   SPSS_FMT_DATE,SPSS_FMT_ADATE,SPSS_FMT_JDATE,SPSS_FMT_EDATE,SPSS_FMT_SDATE:
                 begin
                   spssConvertSPSSDate (xday,xmonth,xyear,nValue);
                   tstr:=format(VF[i],[xyear,xmonth,xday]);
                 end;
                 else
                   tstr:=format(VF[i],[nValue]);
                 end;
           //   end;
              tstr:=copy('          ',1,(Vwide[i]-length(tstr)))+tstr;
              stringgrid1.cells[i1,j]:=tstr;
            end;
         end
         else begin //
            error:=spssGetValueChar(fh,handlesV[i],cValue,256);
            if error = SPSS_OK then begin
               tstr:=format(VF[i],[cValue]);
               stringgrid1.cells[i1,j]:=tstr;
            end;
         end;
        end;
    end;
 //close
    error:=spssCloseRead(fh);
    label2.caption:=filename;
end;

procedure TfrmDPGrid.FormResize(Sender: TObject);
begin
  StringGrid1.left:=0;
  StringGrid1.top:=60;
  StringGrid1.Width:=ClientWidth;
  StringGrid1.Height:=ClientHeight-60;
end;

procedure TfrmDPGrid.btnOKClick(Sender: TObject);
begin
//   exit;
   Form1.show;
end;

procedure TfrmDPGrid.StringGrid1Click(Sender: TObject);
begin
  snameV:=trim(stringgrid1.cells[stringgrid1.col,0]);
  svLabel:='';
  frmValue:=TfrmValue.create(application);
  frmValue.showmodal;
  frmValue.Free;
end;

procedure TfrmDPGrid.Button1Click(Sender: TObject);
begin
    if filename<>'' then begin
      if frmVariable=nil then
      frmVariable:=tfrmVariable.create(application);
      WhereComeFrom:='DPGrid';
      frmVariable.WindowState := wsNormal;
      frmVariable.show;
    end;
end;

//o
procedure TfrmDPGrid.btmWriteClick(Sender: TObject);
var
  outfile:string;
  i1:integer;
  i,j,x:integer;
  f2:Textfile;
begin
   if filename='' then exit;
   SaveDialog1.execute;
   outfile := SaveDialog1.FileName;
   if outfile='' then exit;
   x:= MessageDlg('ۑǂ܂H ܂܁i͂j^ rorr`ij',
      mtConfirmation, [mbYes, mbNo, mbCancel], 0) ;

   if x=  mrCANCEL then exit;//mLZn{^I
   AssignFile(f2,outfile);
   Rewrite(f2);
   if x=mryes then begin
      for j:=1  to nCases do begin
        for i:=1 to numV do
           write(f2,stringgrid1.cells[i,j]+' ');
        writeln(f2);
      end;
   end ;
   if x=mrno then begin
   filecheck;
   for j:= 1 to nCases do begin
       error:=spssReadCaseRecord(fh);
       if error<>SPSS_OK then begin
          showmessage('f[^ǂݍݒɃguFēx킵Ă');
          exit;
       end;
       for i1:= 1 to numV do begin
        i:=i1-1;
         //
         if (typesV[i]=0) then begin
            error:=spssGetValueNumeric(fh,handlesV[i],nValue);
            if error =SPSS_OK then begin
              write(f2,nValue,' ');
            end;
         end
         else begin //
            error:=spssGetValueChar(fh,handlesV[i],cValue,256);
            if error = SPSS_OK then begin
              write(f2,cValue,' ');
            end;
         end;
        end;
        writeln(f2);
    end;
    end;
    closefile(f2);
 //close
    error:=spssCloseRead(fh);
    beep;
end;

end.
