unit ValueLabel;
 //value label l\
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;


type
  TfrmValue = class(TForm)
    ListBox1: TListBox;
    varname: TLabel;
    Label1: TLabel;
    btnOK: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  frmValue: TfrmValue;

implementation

{$R *.DFM}

uses spssdio1,spssfile;
//tH[쐬 Fꂪׂ
procedure TfrmValue.FormCreate(Sender: TObject);

procedure missingvalues;

var
   ftype:integer;
   miss1:double;
   miss2:double;
   miss3:double;
   smiss1,smiss2,smiss3,stypef:string;
begin
  error := spssGetVarNMIssingValues
     (fh,pchar(snameV),ftype,miss1,miss2,miss3);
  if (error=SPSS_OK) then begin
    ListBox1.Items.Add('');
    ListBox1.Items.Add('** missing values **');
    smiss1:=format(VF[iV],[miss1]);
    smiss2:=format(VF[iV],[miss2]);
    smiss3:=format(VF[iV],[miss3]);
    stypef:=format('%3d',[ftype]);
    case ftype of
      SPSS_MISS_RANGE:
       ListBox1.Items.Add(smiss1+'  '+smiss2+' ܂') ;
      SPSS_MISS_RANGEANDVAL:
       ListBox1.Items.Add(smiss1+'  '+smiss2+' ܂, '+smiss3) ;
      0:
        ListBox1.Items.Add('Ȃ');
      1:
         ListBox1.Items.Add(smiss1);
      2:
         ListBox1.Items.Add(smiss1+', '+smiss2);
      3:
         ListBox1.Items.Add(smiss1+', '+smiss2+', '+smiss3);
      else
            ListBox1.Items.Add('type wɊԈႢ܂:'+stypef);
    end;
 end;
end;

var
   tstr:string;
   ValuesL: PValues;
   labelsL: PLabels;
   numL:integer;
   i:integer;

begin
    if filename='' then exit;
    filecheck;
    varname.caption := snameV;
//    label1.caption := svLabel;
    error:=spssGetVarLabel(fh,pchar(snameV),vLabel);
    if (error = SPSS_OK) then  label1.caption :=vLabel
        else  label1.caption :='';
    error:=spssGetVarNValueLabels(fh,pchar(snameV),ValuesL,labelsL,numL);
    if (error <> SPSS_OK) then  begin
      case error of
       SPSS_NO_LABELS ,SPSS_NO_LABEL:
        ListBox1.Items.Add('** no value labels **');
      end;
    end;
    if (error = SPSS_OK) then begin
      for i:=0 to numL-1 do begin
//          tstr:=format('%10.3f',[ValuesL^[i]]);
          tstr:=format(VF[iV],[ValuesL^[i]]);
          ListBox1.Items.Add(tstr+'  '+labelsL^[i]);
      end;
    error:=spssFreeVarNValueLabels(ValuesL[0],labelsL[0],numL);
      //if (error <> SPSS_OK) then  showmessage(errorcode(error));
    end;
    missingvalues;
    error:=spssCloseRead(fh);
    if (error <> SPSS_OK) then  showmessage(errorcode(error));
end;

//tH[̑傫ςƂ
procedure TfrmValue.FormResize(Sender: TObject);
begin
  ListBox1.left:=0;
  ListBox1.top:=56;
  ListBox1.Width:=ClientWidth;
  ListBox1.Height:=ClientHeight-56;

end;

procedure TfrmValue.btnOKClick(Sender: TObject);
begin
  exit;
end;

end.

