unit spssfile;

interface


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    fileget: TBitBtn;
    Button3: TButton;
    Label2: TLabel;
    Button4: TButton;
    Button5: TButton;
    SaveDialog1: TSaveDialog;
    Memo1: TMemo;
    procedure filegetClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormResize(Sender: TObject);


  private
    { Private 錾 }
  public
    { Public 錾 }

  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses spssdio1, vardisp, DPGrid;
//Tu[eBẼtH[̏o͕\
procedure startcheck;
var tstr:string;
//    relInfo:array[0..7] of integer;
//    i:integer;
    sysName:idtype;
    filedate,filetime:vartype;
begin
  if filename='' then exit;
  error:=spssOpenRead(pchar(filename),fh);
  if error=0 then begin
  //̃VXe
     error:=spssGetSystemString(fh,sysName);
     if (error = SPSS_OK) then form1.memo1.lines.Add('Original System:  '+sysName);
  //timestamp
     error:=spssGetTimeStamp(fh,filedate,filetime);
     if (error = SPSS_OK) then form1.memo1.lines.Add('쐬:          '+filedate+' '+filetime);


  //release information
 {    error:=spssGetReleaseInfo(fh,relInfo[0]);
     if (error = SPSS_OK) then begin
       for i:=0 to 7 do begin
          tstr:=format('%3d',[i])+' '+format('%8d',[relInfo[i]]);
           form1.memo1.lines.Add(tstr);
       end;
     end;  }
 //case 
     error:=spssGetNumberofCases(fh,nCases);
     tstr:=format('%8d',[nCases]) ;
     if (error = SPSS_OK) then form1.memo1.lines.Add( 'P[X: '+tstr);
     error:=spssGetNumberofVariables(fh,numV);
     tstr:= format('%8d',[numV]) ;
     if (error = SPSS_OK) then  form1.memo1.lines.Add('ϐ̐: '+tstr);
     form1.memo1.lines.Add('');
 //get id
     error:=spssGetIdString(fh,id);
     tstr:=id;
     tstr:=trim(tstr);
     if tstr='' then tstr:='No Label';
     if (error = SPSS_OK) then form1.memo1.lines.Add('File label:   '+tstr);

//compression switch
     error:=spssGetCompression(fh,compSwitch);
     if (error = SPSS_OK) then begin
        if compSwitch=1 then form1.memo1.lines.Add('kF       Yes')
                        else form1.memo1.lines.Add('kF       No ') ;
     end;
 //case weight var
     error:=spssGetCaseWeightVar(fh,caseWeight);
     if (error = SPSS_NO_CASEWGT) then
         form1.memo1.lines.Add('d݂ÂF No')
         else begin
         if (error= SPSS_OK) then
              form1.memo1.lines.Add('f[^̏d݂ÂϐF '+caseWeight)
         end;

      sysmis:=spssSysmisVal;
      tstr:=format('%20.8f',[sysmis]);
      form1.memo1.lines.Add('sysmis= '+tstr);
     form1.memo1.lines.Add('--------------------------------');
 //file close
     error:=spssCloseRead(fh);
    end
    else
    form1.memo1.lines.Add('t@CJƂɎs܂');
  end;
//rorrf[^t@C擾
procedure TForm1.filegetClick(Sender: TObject);
begin
   OpenDialog1.execute;
   filename := OpenDialog1.FileName;
   form1.memo1.lines.Add('file:'+filename);
   startcheck;
   if filename<>'' then begin
     Label2.Caption:=filename;
     if frmDPGrid <> nil then begin
       frmDPGrid.free;
       frmDPGrid:=nil;
     end;
     if frmVariable<> nil then frmVariable.free;
     frmVariable:=tfrmVariable.create(application);
   end
   else
   exit;
end;
//ϐtH[J
procedure TForm1.Button3Click(Sender: TObject);
begin
    if filename<>'' then begin
      if frmVariable =nil then
        frmVariable:=tfrmVariable.create(application);
      WhereComeFrom:='spssfile';           //߂Ă悤ɏoL
      frmVariable.WindowState := wsNormal; //ACR̎Ɍɖ߂
      frmVariable.show;
    end;
end;

//̃tH[Ƃɂ邱
procedure TForm1.FormCreate(Sender: TObject);
begin
   filename:='';
   OpenDialog1.execute;
   filename := OpenDialog1.FileName;
   form1.memo1.lines.Add('file:'+filename);
   startcheck;
   if filename<>'' then begin
     Label2.Caption:=filename;
     frmVariable:=tfrmVariable.create(application);
   end
   else
   exit;
end;
//I{^
procedure TForm1.Button4Click(Sender: TObject);
begin
 application.terminate;
end;
//f[^\{^
procedure TForm1.Button5Click(Sender: TObject);
begin
    if nCases=-1 then begin
       showmessage('̃f[^͓ǂ߂܂:Matrix DATA ł');
       exit;
    end;
    if filename<>'' then begin
      if frmDPGrid = nil then
          frmDPGrid:=tfrmDPGrid.create(application);
      if frmDPGrid.WindowState = wsMinimized then
          frmDPGrid.WindowState := wsNormal;
      frmDPGrid.show;
    end;

end;
//tH[Ƃi쐬܂ށj
procedure TForm1.FormResize(Sender: TObject);
begin
  Memo1.left:=0;
  Memo1.top:=70;
  Memo1.Width:=ClientWidth;
  Memo1.Height:=ClientHeight-70;

end;


end.


