unit vardisp;
  //SϐƂ̕ϐx̕\
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TfrmVariable = class(TForm)
    ListBox1: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    btnOK: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  frmVariable: TfrmVariable;

implementation

{$R *.DFM}
uses spssdio1,spssfile, ValueLabel, DPGrid;


procedure TfrmVariable.FormCreate(Sender: TObject);

function MisVal(nameV:Pchar) :string;

var
   ftype:integer;
   miss1:double;
   miss2:double;
   miss3:double;
begin
  MisVal:='N';
  error := spssGetVarNMIssingValues
     (fh,pchar(nameV),ftype,miss1,miss2,miss3);
  if (error=SPSS_OK) then begin
    if ftype<>0 then MisVal:='m';
 end;
end;

function IsThereVarLabels(nameV:pChar):string;
var
  ValuesL: PValues;
  labelsL: PLabels;
  numL:integer;
begin
     IsThereVarLabels:='L';
    error:=spssGetVarNValueLabels(fh,pchar(nameV),ValuesL,labelsL,numL);
    if (error <> SPSS_OK) then  begin
      case error of
       SPSS_NO_LABELS ,SPSS_NO_LABEL:
        IsThereVarLabels:='N'
      end;
    end;
end;


var
  i:integer;
  error2:integer;
  tstr:string;
  tstr2:string;
begin
  if filename='' then exit;
  filecheck;
  label1.Caption:=filename;
  error:=spssGetNumberofVariables(fh,numV);

  if (error <> SPSS_OK) then begin
    showmessage('File handle error at getVarInfo:'+errorcode(error));
    exit;
  end;
  for i:=0 to numV-1 do begin
   error:=spssGetVarInfo(fh,i,nameV[i],typesV[i]);
   if (error = SPSS_OK) then begin
     tstr:=copy(nameV[i]+'          ',1,10);
     if typesV[i]=SPSS_NUMERIC then begin
       tstr:=tstr+'num    ';
     end
     else begin
       tstr2:=format('%3d',[typesV[i]]);
       tstr:=tstr+'str'+tstr2+' ';
     end;
     tstr:=tstr+IsThereVarLabels(nameV[i])+'  '+MisVal(nameV[i])+'  ';
     //spssGetVarLabel
     error2:=spssGetVarLabel(fh,nameV[i],vLabel);
     if (error2 = SPSS_OK) then  tstr:=tstr+vLabel;
     ListBox1.Items.Add(tstr);
     end
     else begin
     showmessage('File handle error at getVarInfo:'+errorcode(error));
     exit;
     end;
     //spssGetVarPrintFormat
     error:=spssGetVarPrintFormat(fh,nameV[i],typesVF[i],dec,wid);
     //showmessage(inttostr(typesVF[i]));
  //   if typesVF[i]=20,23,24,38,39
     if (error = SPSS_OK) then begin
       VWide[i]:=wid;
       if typesV[i]= 0 then begin //
       case typesVF[i] of
          SPSS_FMT_DATE,SPSS_FMT_ADATE,SPSS_FMT_JDATE,SPSS_FMT_EDATE,SPSS_FMT_SDATE:
            begin
              VWide[i]:=11;
              tstr:='%4d/%2d/%2d' ;
              VF[i]:=tstr;
            end;
          else begin
            tstr:='%'+trim(format('%3d',[wid]))+'.'+trim(format('%3d',[dec]))+'f';
            VF[i]:=tstr;
          end;
       end;
       end
       else
          VF[i]:='%'+trim(format('%3d',[wid])) +'s';
 //     showmessage(vf[i]);
     end
     else
     showmessage('Error at spssGetVarPrintFormat.'+errorcode(error));
      //spssGetVarWriteFormat
     error:=spssGetVarWriteFormat(fh,nameV[i],typeVF,dec,wid);
     if (error = SPSS_OK) then begin
       VWide[i]:=wid;
       if typesV[i]= 0 then begin //
          tstr:='%'+trim(format('%3d',[wid]))+'.'+trim(format('%3d',[dec]))+'f';
          VWriteF[i]:=tstr;
       end
       else
          VWriteF[i]:='%'+trim(format('%3d',[wid])) +'s';
 //     showmessage(vf[i]);
     end
     else
     showmessage('Error at spssGetVarPrintFormat.'+errorcode(error));

 //    showmessage(VWriteF[i]+' '+VF[i]) ;
  end;
end;
procedure TfrmVariable.ListBox1DblClick(Sender: TObject);
var
  iitem:string;
begin
  iitem:=ListBox1.Items[ListBox1.ItemIndex];
  iV:=ListBox1.ItemIndex;
//  showMessage(iitem);
  snameV:=trim(copy(iitem,1,8));
  svLabel:='';
  frmValue:=TfrmValue.create(application);
  frmValue.showmodal;
  frmValue.Free;
end;

procedure TfrmVariable.btnOKClick(Sender: TObject);
begin
  if WhereComeFrom='spssfile' then Form1.show;
  if WhereComeFrom='DPGrid'   then frmDPGrid.show;
end;

procedure TfrmVariable.FormResize(Sender: TObject);
begin
  ListBox1.left:=0;
  ListBox1.top:=56;
  ListBox1.Width:=ClientWidth;
  ListBox1.Height:=ClientHeight-56;

end;

end.
